--A spin move inspired by F-ZERO. Gives players a damaging move with no item. Press Item to do damage by crashing into a player
--Also gives a short amount flashtics so it can be used as a parry.
--Created by NepDisk with extra code created by Indev and Onyo

--performance shit
local k_eggmanexplode = k_eggmanexplode
local k_growshrinktimer = k_growshrinktimer
local k_invincibilitytimer = k_invincibilitytimer
local k_spinouttimer = k_spinouttimer
local k_itemtype = k_itemtype
local k_itemroulette = k_itemroulette
local k_itemheld = k_itemheld
local k_eggmanheld = k_eggmanheld
local k_rocketsneakertimer = k_rocketsneakertimer
local k_stolentimer = k_stolentimer
local k_stealingtimer = k_stealingtimer
local k_growshrinktimer = k_growshrinktimer
local FRACUNIT = FRACUNIT

--On or off?
local cv_fzerospin = CV_RegisterVar({
    name = "nepspin",
    defaultvalue = "On",
    possiblevalue = CV_OnOff,
    flags = CV_NETVAR,
})

--The spin itself
local cv_fzerospintimer = CV_RegisterVar({
    name = "nepspin_timer",
    defaultvalue = "22",
    flags = CV_NETVAR,
	possiblevalue =  {MIN = 0, MAX = 999}
})

--Duration of flashtics
local cv_fzerospintics = CV_RegisterVar({
    name = "nepspin_flashnumtics",
    defaultvalue = "6",
    flags = CV_NETVAR,
	possiblevalue =  {MIN = 0, MAX = 999}
})

--Cooldown After use
local cv_fzerospincooldown = CV_RegisterVar({
    name = "nepspin_cooldown",
    defaultvalue = "210",
    flags = CV_NETVAR,
	possiblevalue =  {MIN = 0, MAX = 999}
})

--Cooldown Given at race start
local cv_fzerospinracecooldown = CV_RegisterVar({
    name = "nepspin_racecooldown",
    defaultvalue = "490",
    flags = CV_NETVAR,
	possiblevalue =  {MIN = 0, MAX = 999}
})

--Should hits reward the player by reducing cooldown?
local cv_fzerospincoolreduction = CV_RegisterVar({
    name = "nepspin_rewardreduction",
    defaultvalue = "On",
    possiblevalue = CV_OnOff,
    flags = CV_NETVAR,
})

--Number to divide cooldown timer by
local cv_fzerospincooldivisor = CV_RegisterVar({
    name = "nepspin_rewardreductiondivisor",
    defaultvalue = "2",
    flags = CV_NETVAR,
	possiblevalue =  {MIN = 0, MAX = 999}
})

--Number to add to driftboost timer on hit
local cv_fzerospinsparkreward = CV_RegisterVar({
    name = "nepspin_rewardspark",
    defaultvalue = "25",
    flags = CV_NETVAR,
	possiblevalue =  {MIN = 0, MAX = 999}
})

--hud debug info
local cv_fzerospindebug = CV_RegisterVar({
    name = "nepspin_debug",
    defaultvalue = "Off",
    possiblevalue = CV_OnOff,
    flags = CV_NETVAR,
})


local function setplayerspinvars(p)
	p.nspintimer = 0
	p.nspinready = 1
	p.nspintics = 0
	p.nspincooldown =  cv_fzerospinracecooldown.value
	p.nspininput = 0
	p.nspinplyrlck = 0
	p.nspinnotify = 0
	p.nspinicontimer = 0
end 

local function spinmove(p)
	if(not p.kartstuff[k_invincibilitytimer]) then
		if p.nspintimer and p.nspintics
			--Hide flashing and colorize player to Show FlashTics
			p.mo.colorized = true
	end
            p.mo.flags2 = $ & ~MF2_DONTDRAW
			
		end
	
		
		--Thok Trail
		local thok = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
		thok.color = p.skincolor
		thok.scale = p.mo.scale*3/5
		
		--Spin timers
		p.nspintimer = max($ - 1, 0)
		p.nspintics = max($ - 1,0)
		
		--Give FlashTics and animate spin
		p.powers[pw_flashing] = p.nspintics
		p.frameangle = $1 + ANGLE_22h * p.spinanim -- The actual *spinning*.
	

end

--thanks indev
local function onCollide(pmo, pmo2)
    if not cv_fzerospin.value then return end -- Don't care if cvar is off
    if not pmo2.player then return end -- Don't care about non-players
    
    -- ffs srb2 why do i have to do this - Indev
    if pmo.z > pmo2.z+pmo2.height or pmo.z+pmo.height < pmo2.z then return end

	-- Setup player variables
    local player = pmo.player
    local otherplayer = pmo2.player
	
	--Check if source player is spinning and make sure victim doesn't have FlashTics
    if otherplayer.nspintimer and not player.powers[pw_flashing] then
			--Hitfeed message
			if (hitfeed)
				local s = {{otherplayer.name, otherplayer.mo.hf_overridenamecolor or otherplayer.skincolor}, {skins[otherplayer.mo.skin].facemmap, otherplayer.skincolor}, otherplayer}
				local v = {{player.name, player.mo.hf_overridenamecolor or player.skincolor}, {skins[player.mo.skin].facemmap, player.skincolor}, player}
				local icon = "K_HMSPIN"
				HF_SendHitMessage(s, v, icon)
			end
		
			--Spinout Victim Player
			K_SpinPlayer(player, pmo2.player.mo, 1, pmo2.player.mo, false)
			
			--Do damage in hpmod to victim if aviliable
			if hpmod and hpmod.running then hpmod_damagehp(player, 5, otherplayer) end
		
		--Spin Lock check. 
		--To prevent certain actions from repeating when inside someone
		if otherplayer.nspinplyrlck == 0
			--Add miniturbo reward to source player
			otherplayer.kartstuff[k_driftboost] = $ + cv_fzerospinsparkreward.value
			
			--Play sound based on if you passthrough or bonk
			if otherplayer.nspintics == 0
				S_StartSound(player.mo, sfx_s1b4)
			elseif otherplayer.nspintics > 0 and not otherplayer.kartstuff[k_justbumped]
				S_StartSound(player.mo, sfx_s1ba)
			end
			
			--Push Victim player 
			P_Thrust(player.mo,otherplayer.mo.angle,FRACUNIT*10)
			
			--Reduce source player cooldown timer on hit and set lock
			if cv_fzerospincoolreduction.value
				otherplayer.nspincooldown = $ / cv_fzerospincooldivisor.value
			end
			otherplayer.nspinplyrlck = 1
		end
		
		--Check if source player is spinning and make sure victim doesn't have FlashTics
		elseif player.nspintimer and not otherplayer.powers[pw_flashing] then
			--Hitfeed message
			if (hitfeed)
				local v = {{otherplayer.name, otherplayer.mo.hf_overridenamecolor or otherplayer.skincolor}, {skins[otherplayer.mo.skin].facemmap, otherplayer.skincolor}, otherplayer}
				local s = {{player.name, player.mo.hf_overridenamecolor or player.skincolor}, {skins[player.mo.skin].facemmap, player.skincolor}, player}
				local icon = "K_HMSPIN"
				HF_SendHitMessage(s, v, icon)
			end
			
			--Spinout Victim Player
			K_SpinPlayer(otherplayer, pmo.player.mo, 1 , pmo.player.mo, false)
			
			--Do damage in hpmod to victim if aviliable
			if hpmod and hpmod.running then hpmod_damagehp(otherplayer, 5, player) end
			
		--Spin Lock check. 
		--To prevent certain actions from repeating when inside someone
		if player.nspinplyrlck == 0
			--Add miniturbo reward to source player
			player.kartstuff[k_driftboost] = $ + cv_fzerospinsparkreward.value
			
			--Play sound based on if you passthrough or bonk
			if player.nspintics == 0
				S_StartSound(otherplayer.mo, sfx_s1b4)
			elseif player.nspintics > 1 and not player.kartstuff[k_justbumped]
				S_StartSound(otherplayer.mo, sfx_s1ba)
			end
			
			--Push Victim player 
			P_Thrust(otherplayer.mo,player.mo.angle,FRACUNIT*10)
			
			--Reduce source player cooldown timer on hit and set lock
			if cv_fzerospincoolreduction.value
				player.nspincooldown = $ / cv_fzerospincooldivisor.value
			end
			player.nspinplyrlck = 1
		end
		
    end
end

local function cancelSpin(player)
if not cv_fzerospin.value then return end
    if not (player.mo and player.mo.valid) then return end
	player.nspintimer = 0
	player.nspintics = 0
	
end


local function countActiveSplitScreenPlayers()
	if not splitscreen return 1 end

	local number = 0

	for p in displayplayers.iterate do
		if p.valid then number = $ + 1 end
	end

	return number
end

local function whichSplitscreenPlayerIsThis(thisPlayer)
	if not splitscreen return 1 end
	
	local number = 1
	local howManyPlayers = countActiveSplitScreenPlayers()

	if howManyPlayers == number then return number
	elseif howManyPlayers > 1 then
		for p in displayplayers.iterate do
			if p == thisPlayer then break
			else number = $ + 1
			end
		end
	end 

	return number
end



--Reload reload playervars at the start of everyrace
addHook("MapLoad", do
if not cv_fzerospin.value then return end
    for p in players.iterate do 
		p.nspinready = nil
		if p.mo and not p.spectator
			setplayerspinvars(p)
		end
    end 
end)

addHook("PlayerThink", function(p)
if not cv_fzerospin.value then return end
if not (p.mo and p.mo.valid) then return end
local p_spinning = (p.mo.state == S_KART_SPIN or p.mo.state == S_KART_PAIN)

	--Setup spin if player joins mid-game
	if not p.nspinready then
		setplayerspinvars(p) 
	end
	
	--I hope you like timers :)
	if  p.nspincooldown > 0 then -- If there's a cooldown...
		p.nspincooldown = $1 - 1 -- Decrease it.
	end
	
	if  p.nspinicontimer > 0 then -- If there's a cooldown...
		p.nspinicontimer = $1 - 1 -- Decrease it.
	end
	
	if not p.nspintimer then
		 p.nspinplyrlck = 0
		 p.spinanim = 10
	end
		
	if ((p.cmd.buttons & BT_ATTACK)) then
		p.nspininput = min($ + 1, 5)
	else
		p.nspininput = 0
	end
		
	if (p.nspintimer > 0) then 
		spinmove(p)
		p.nspinnotify = 0
		p.spinanim = $ + 1
    elseif (p.kartstuff[k_pogospring] == 0 and not p_spinning) then 
		p.frameangle = p.mo.angle
    end
	
	if (p.nspincooldown == 0) and not p.nspinnotify then
		S_StartSound(nil, sfx_cdfm68, p)
		p.nspinicontimer = 14
		p.nspinnotify = 1
	end
		
		
	--Spin input detection
	if p.nspininput == 1 then 
		if p.playerstate == PST_LIVE
		and not p.nspincooldown 
		and not p.spinlfroulette and not p.spinlfitem
		and not p.spinlfheld and not p.spinlfeggman
		and not p.spinlfsneaker and not p.kartstuff[k_eggmanexplode] 
		and not p.spinlfstolen and not p.spinlfstealing
		and not p.spinlfgrow and not p.kartstuff[k_respawn]
		and not p.kartstuff[k_spinouttimer] then
			S_StartSound(p.mo, sfx_s3k40)
			p.nspintimer = cv_fzerospintimer.value
			p.nspintics = cv_fzerospintics.value
			p.nspincooldown = cv_fzerospincooldown.value
		end
	end
	
		--Update timers at end of frame
		p.spinlfitem = p.kartstuff[k_itemtype]
        p.spinlfroulette = p.kartstuff[k_itemroulette]
		p.spinlfheld = p.kartstuff[k_itemheld]
		p.spinlfeggman = p.kartstuff[k_eggmanheld]
		p.spinlfsneaker = p.kartstuff[k_rocketsneakertimer]
		p.spinlfgrow = p.kartstuff[k_growshrinktimer]
		p.spinlfstolen = p.kartstuff[k_stolentimer]
		p.spinlfstealing = p.kartstuff[k_stealingtimer]
end)

--Cancel Spin if spunout
addHook("PlayerSpin", cancelSpin)	
addHook("PlayerExplode", cancelSpin)
addHook("PlayerSquish", cancelSpin)

--Player Collide
addHook("MobjCollide", onCollide, MT_PLAYER)
addHook("MobjMoveCollide", function(pmo2, pmo)
    if pmo.player then return onCollide(pmo, pmo2) end
end, MT_PLAYER)


--Hud Code starts here
hud.add(function(v, p, c)
	if not cv_fzerospin.value then return end
	if not (p.mo and p.mo.valid) return end
	
	--Splitscreen stuff
	local splitscreenNum = countActiveSplitScreenPlayers()
	local thisPlayer = whichSplitscreenPlayerIsThis(p)
	
	
	--On-screen Debug
	if cv_fzerospindebug.value then
	local flags = V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE
		v.drawString(9, 70, "Spin Timer: "..p.nspintimer, flags, "thin")
		v.drawString(9, 80, "Spin FlashTics: "..p.nspintics, flags, "thin")
		v.drawString(9, 90, "Spin Cooldown: "..p.nspincooldown, flags, "thin")
		v.drawString(9, 100, "Spin Input: "..p.nspininput, flags, "thin")
		v.drawString(9, 110, "MiniTurbo: "..p.kartstuff[k_driftboost], flags, "thin")
		v.drawString(9, 120, "PlayerHit Lock: "..p.nspinplyrlck, flags, "thin")
		v.drawString(9, 130, "AnimationTimer: "..p.spinanim, flags, "thin")
		end
			
	local hudcolor = v.getColormap(TC_DEFAULT, p.skincolor)
	local hudicon = ""
	local hudiconX = 16
	local hudiconY = 16
	local hudiconoffset
	
	--making this a var so tis less annoying to type
	local disabledbox = (p.playerstate == 1 or p.playerstate == 2 or p.spinlfroulette or p.spinlfitem or p.spinlfheld or p.spinlfeggman or p.spinlfsneaker or p.kartstuff[k_eggmanexplode] or p.kartstuff[k_spinouttimer] or p.spinlfstealing or p.spinlfstealing or p.spinlfgrow or p.kartstuff[k_respawn])
	local iflags = V_SNAPTOLEFT|V_SNAPTOTOP|V_HUDTRANS
	
	--Makes editing these statments used in the hud code easier :)
	local iconstatetbl =
	{
		[1] = p.nspincooldown and (p.nspincooldown&3)  and splitscreenNum <= 2 and p.nspincooldown <= cv_fzerospincooldown.value,
		[2] = p.nspincooldown and not (p.nspincooldown&3)  and splitscreenNum <= 2 and p.nspincooldown <= cv_fzerospincooldown.value,
		[3] = not p.nspincooldown and not p.nspinicontimer and splitscreenNum <= 2 and disabledbox,
		[4] = not p.nspincooldown and p.nspinicontimer and (p.nspinicontimer&3) and splitscreenNum <= 2 and disabledbox,
		[5] = not p.nspincooldown and not p.nspinicontimer  and splitscreenNum <= 2,
		[6] = not p.nspincooldown and p.nspinicontimer and (p.nspinicontimer&3) and splitscreenNum <= 2  and not disabledbox,
		[7] = not p.nspincooldown and p.nspinicontimer and not (p.nspinicontimer&3) and splitscreenNum <= 2 and not disabledbox,
		[8] = not p.nspincooldown and p.nspinicontimer and not (p.nspinicontimer&3) and splitscreenNum <= 2 and disabledbox,
		[9] = p.nspincooldown and (p.nspincooldown&3)   and splitscreenNum >= 3 and p.nspincooldown <= cv_fzerospincooldown.value,
		[10] = p.nspincooldown and not (p.nspincooldown&3) and splitscreenNum >= 3 and p.nspincooldown <= cv_fzerospincooldown.value,
		[11] = not p.nspincooldown and not p.nspinicontimer and splitscreenNum >= 3 and disabledbox,
		[12] = not p.nspincooldown and p.nspinicontimer and (p.nspinicontimer&3) and splitscreenNum >= 3 and disabledbox,
		[13] = not p.nspincooldown and not p.nspinicontimer and splitscreenNum >= 3,
		[14] = not p.nspincooldown and p.nspinicontimer and (p.nspinicontimer&3) and splitscreenNum >= 3,
		[15] = not p.nspincooldown and p.nspinicontimer and not (p.nspinicontimer&3) and splitscreenNum >= 3 and not disabledbox,
		[16] = not p.nspincooldown and p.nspinicontimer and not (p.nspinicontimer&3) and splitscreenNum >= 3 and disabledbox,
		[17] = p.nspincooldown > cv_fzerospincooldown.value and splitscreenNum <= 2,
		[18] = p.nspincooldown > cv_fzerospincooldown.value and splitscreenNum >= 3,
		
	}
	
	--Change icon graphic based on spincooldown
	if iconstatetbl[17] then
		hudicon = "SPNHD4"
	elseif iconstatetbl[1] then
		hudicon = "SPNHD1" 
	elseif  iconstatetbl[2] then
		hudicon = "SPNHD4"
	elseif iconstatetbl[3] then
		hudicon = "SPNHD2"
	elseif iconstatetbl[4] then
		hudicon = "SPNHD2"
	elseif iconstatetbl[5] then
		hudicon = "SPNHD3"
	elseif iconstatetbl[6] then
		hudicon = "SPNHD3"
	elseif iconstatetbl[7] then
		hudicon = "SPNHDF"
	elseif iconstatetbl[8] then
		hudicon = "SPNHDF"
	
	--Mini icons start here
	elseif iconstatetbl[18] then
		hudicon = "SPNHS4"
	elseif iconstatetbl[9] then
		hudicon = "SPNHS1"
	elseif iconstatetbl[10] then
		hudicon = "SPNHS4"
	elseif iconstatetbl[11] then
		hudicon = "SPNHS2"
	elseif iconstatetbl[12] then
		hudicon = "SPNHS2"
	elseif iconstatetbl[13] then
		hudicon = "SPNHS3"
	elseif iconstatetbl[14] then
		hudicon = "SPNHS3"
	elseif iconstatetbl[15] then
		hudicon = "SPNHSF"
	elseif iconstatetbl[16] then
		hudicon = "SPNHSF"
	end
	
	--making this a var so tis less annoying to type
	local disabledbox2 = (p.spinlfroulette or p.spinlfitem or p.spinlfheld or p.spinlfeggman or p.spinlfsneaker or p.kartstuff[k_eggmanexplode] or p.spinlfstealing or p.spinlfstolen or p.spinlfgrow)
	
	--Icon X offset when Itembox is on screen
	if disabledbox2
		if	splitscreenNum >= 3 and not (thisPlayer % 2 == 0 or thisPlayer % 4 == 0)
			hudiconX = $ + 25
		elseif splitscreenNum >= 3 and (thisPlayer % 2 == 0 or thisPlayer % 4 == 0)
			hudiconX = $ - 25
		elseif splitscreenNum <= 2
			hudiconX = $ + 40
		end
	end
	
	if splitscreenNum == 2 and thisPlayer % 2 == 0 then
		hudiconY = $ + 110
	end
	
	if splitscreenNum >= 3 then
		
		if thisPlayer % 1 == 0 or  thisPlayer % 2 == 0 then
			hudiconY = $ + -13
		end
		
		if thisPlayer % 3 == 0 or  thisPlayer % 4 == 0 then
			hudiconY = $ + 100 + 13
		end
		
		if thisPlayer % 1 == 0 or thisPlayer % 3 == 0 then
			hudiconX = $ - 15
		end	
		
		if thisPlayer % 4 == 0 or thisPlayer % 2 == 0 then
			hudiconX = $ + 367
		end	
	end
	
	--acutally drawing the icon
	v.draw(hudiconX, hudiconY, v.cachePatch(hudicon), iflags, hudcolor)
					
		--thanks to Onyo for bar code
		if p.nspincooldown then
		
			--offsets and what not
			local barX		= hudiconX 
			local barY 		
			local barWidth  
			
			--Splitscreen
			if splitscreenNum >= 3
				barWidth = 22 
				barX = hudiconX + 1
				barY = hudiconY + 20
			else
				barWidth = 30
				barX = hudiconX 
				barY = hudiconY + 27
			end
			
			local flags		= V_SNAPTOTOP|V_SNAPTOLEFT|V_HUDTRANS
			local timer = 0
			local maxDuration = 0
			
			
			--Setup bar to use values
			if p.nspincooldown then
				timer = p.nspincooldown -- read value of cooldown timer
				maxDuration = cv_fzerospincooldown.value
			end
			
			--Time to draw the bar
			if timer > 0 then
			
				--if timer is bigger then maxDuration then don't draw
				if timer > maxDuration return end
				
				--modified this to make sure bar doesn't draw more then max
				--Doesn't matter though since its hidden anyway :p
				local funnyCalc1 = FixedMul(FixedDiv(FixedDiv((barWidth * 100) * FRACUNIT, maxDuration * FRACUNIT), 100 * FRACUNIT), min(timer,maxDuration) * FRACUNIT)
				local visualTimer = FixedInt(funnyCalc1)
				
				local barActualWidth = barWidth - visualTimer
				
				--Drawing Bar Background
				v.drawFill(barX, 	barY-1, barWidth, 		1, 21|flags)
				v.drawFill(barX-1, 	barY, 	barWidth + 2, 	1, 23|flags)
				v.drawFill(barX-1, 	barY+1, barWidth + 2, 	1, 24|flags) 
				v.drawFill(barX-1, 	barY+2, barWidth + 2, 	1, 25|flags)
				v.drawFill(barX, 	barY+3, barWidth, 		1, 26|flags)
				
				--Drawing Active Bar
				v.drawFill(barX+1, 	barY, 	barActualWidth - 2, 1, 7|flags)
				v.drawFill(barX, 	barY+1, barActualWidth, 	1, 9|flags)
				v.drawFill(barX+1, 	barY+2, barActualWidth - 2, 1, 12|flags)
				
			end
		end	
end)


